/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.test.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class TypeSwitchInTypeSwitchParentTypeChild2Infant8
    extends TypeSwitchInTypeSwitchParentTypeChild2 implements Message {

  // Accessors for discriminator values.
  public Short getChildNumber() {
    return (short) 0x23;
  }

  // Properties.
  protected final short infantSomeField23;

  public TypeSwitchInTypeSwitchParentTypeChild2Infant8(
      short parentFieldHurz, short childFieldGrueneWiese, short infantSomeField23) {
    super(parentFieldHurz, childFieldGrueneWiese);
    this.infantSomeField23 = infantSomeField23;
  }

  public short getInfantSomeField23() {
    return infantSomeField23;
  }

  @Override
  protected void serializeTypeSwitchInTypeSwitchParentTypeChild2Child(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    int startPos = positionAware.getPos();
    writeBuffer.pushContext("TypeSwitchInTypeSwitchParentTypeChild2Infant8");

    // Simple Field (infantSomeField23)
    writeSimpleField("infantSomeField23", infantSomeField23, writeUnsignedShort(writeBuffer, 8));

    writeBuffer.popContext("TypeSwitchInTypeSwitchParentTypeChild2Infant8");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    TypeSwitchInTypeSwitchParentTypeChild2Infant8 _value = this;

    // Simple field (infantSomeField23)
    lengthInBits += 8;

    return lengthInBits;
  }

  public static TypeSwitchInTypeSwitchParentTypeChild2Builder
      staticParseTypeSwitchInTypeSwitchParentTypeChild2Builder(ReadBuffer readBuffer)
          throws ParseException {
    readBuffer.pullContext("TypeSwitchInTypeSwitchParentTypeChild2Infant8");
    PositionAware positionAware = readBuffer;
    int startPos = positionAware.getPos();
    int curPos;

    short infantSomeField23 =
        readSimpleField("infantSomeField23", readUnsignedShort(readBuffer, 8));

    readBuffer.closeContext("TypeSwitchInTypeSwitchParentTypeChild2Infant8");
    // Create the instance
    return new TypeSwitchInTypeSwitchParentTypeChild2Infant8BuilderImpl(infantSomeField23);
  }

  public static class TypeSwitchInTypeSwitchParentTypeChild2Infant8BuilderImpl
      implements TypeSwitchInTypeSwitchParentTypeChild2
          .TypeSwitchInTypeSwitchParentTypeChild2Builder {
    private final short infantSomeField23;

    public TypeSwitchInTypeSwitchParentTypeChild2Infant8BuilderImpl(short infantSomeField23) {

      this.infantSomeField23 = infantSomeField23;
    }

    public TypeSwitchInTypeSwitchParentTypeChild2Infant8 build(
        short parentFieldHurz, short childFieldGrueneWiese) {
      TypeSwitchInTypeSwitchParentTypeChild2Infant8 typeSwitchInTypeSwitchParentTypeChild2Infant8 =
          new TypeSwitchInTypeSwitchParentTypeChild2Infant8(
              parentFieldHurz, childFieldGrueneWiese, infantSomeField23);
      return typeSwitchInTypeSwitchParentTypeChild2Infant8;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof TypeSwitchInTypeSwitchParentTypeChild2Infant8)) {
      return false;
    }
    TypeSwitchInTypeSwitchParentTypeChild2Infant8 that =
        (TypeSwitchInTypeSwitchParentTypeChild2Infant8) o;
    return (getInfantSomeField23() == that.getInfantSomeField23()) && super.equals(that) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getInfantSomeField23());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
