/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableAudit {
  AuditEventType_ActionTimeStamp((int) 2053L),
  AuditEventType_Status((int) 2054L),
  AuditEventType_ServerId((int) 2055L),
  AuditEventType_ClientAuditEntryId((int) 2056L),
  AuditEventType_ClientUserId((int) 2057L),
  AuditOpenSecureChannelEventType_ClientCertificate((int) 2061L),
  AuditOpenSecureChannelEventType_RequestType((int) 2062L),
  AuditOpenSecureChannelEventType_SecurityPolicyUri((int) 2063L),
  AuditOpenSecureChannelEventType_SecurityMode((int) 2065L),
  AuditOpenSecureChannelEventType_RequestedLifetime((int) 2066L),
  AuditSessionEventType_SessionId((int) 2070L),
  AuditCreateSessionEventType_SecureChannelId((int) 2072L),
  AuditCreateSessionEventType_ClientCertificate((int) 2073L),
  AuditCreateSessionEventType_RevisedSessionTimeout((int) 2074L),
  AuditActivateSessionEventType_ClientSoftwareCertificates((int) 2076L),
  AuditActivateSessionEventType_UserIdentityToken((int) 2077L),
  AuditCancelEventType_RequestHandle((int) 2079L),
  AuditCertificateEventType_Certificate((int) 2081L),
  AuditCertificateDataMismatchEventType_InvalidHostname((int) 2083L),
  AuditCertificateDataMismatchEventType_InvalidUri((int) 2084L),
  AuditAddNodesEventType_NodesToAdd((int) 2092L),
  AuditDeleteNodesEventType_NodesToDelete((int) 2094L),
  AuditAddReferencesEventType_ReferencesToAdd((int) 2096L),
  AuditDeleteReferencesEventType_ReferencesToDelete((int) 2098L),
  AuditWriteUpdateEventType_IndexRange((int) 2101L),
  AuditWriteUpdateEventType_OldValue((int) 2102L),
  AuditWriteUpdateEventType_NewValue((int) 2103L),
  AuditUpdateMethodEventType_MethodId((int) 2128L),
  AuditUpdateMethodEventType_InputArguments((int) 2129L),
  AuditChannelEventType_SecureChannelId((int) 2745L),
  AuditOpenSecureChannelEventType_ClientCertificateThumbprint((int) 2746L),
  AuditCreateSessionEventType_ClientCertificateThumbprint((int) 2747L),
  AuditUrlMismatchEventType_EndpointUrl((int) 2749L),
  AuditWriteUpdateEventType_AttributeId((int) 2750L),
  AuditHistoryUpdateEventType_ParameterDataTypeId((int) 2751L),
  AuditUpdateStateEventType_OldStateId((int) 2777L),
  AuditUpdateStateEventType_NewStateId((int) 2778L),
  AuditHistoryEventUpdateEventType_Filter((int) 3003L),
  AuditHistoryRawModifyDeleteEventType_IsDeleteModified((int) 3015L),
  AuditHistoryRawModifyDeleteEventType_StartTime((int) 3016L),
  AuditHistoryRawModifyDeleteEventType_EndTime((int) 3017L),
  AuditHistoryAtTimeDeleteEventType_ReqTimes((int) 3020L),
  AuditHistoryAtTimeDeleteEventType_OldValues((int) 3021L),
  AuditHistoryEventDeleteEventType_EventIds((int) 3023L),
  AuditHistoryEventDeleteEventType_OldValues((int) 3024L),
  AuditHistoryEventUpdateEventType_UpdatedNode((int) 3025L),
  AuditHistoryValueUpdateEventType_UpdatedNode((int) 3026L),
  AuditHistoryDeleteEventType_UpdatedNode((int) 3027L),
  AuditHistoryEventUpdateEventType_PerformInsertReplace((int) 3028L),
  AuditHistoryEventUpdateEventType_NewValues((int) 3029L),
  AuditHistoryEventUpdateEventType_OldValues((int) 3030L),
  AuditHistoryValueUpdateEventType_PerformInsertReplace((int) 3031L),
  AuditHistoryValueUpdateEventType_NewValues((int) 3032L),
  AuditHistoryValueUpdateEventType_OldValues((int) 3033L),
  AuditHistoryRawModifyDeleteEventType_OldValues((int) 3034L),
  AuditEventType_EventId((int) 3200L),
  AuditEventType_EventType((int) 3201L),
  AuditEventType_SourceNode((int) 3202L),
  AuditEventType_SourceName((int) 3203L),
  AuditEventType_Time((int) 3204L),
  AuditEventType_ReceiveTime((int) 3205L),
  AuditEventType_LocalTime((int) 3206L),
  AuditEventType_Message((int) 3207L),
  AuditEventType_Severity((int) 3208L),
  AuditSecurityEventType_EventId((int) 3209L),
  AuditSecurityEventType_EventType((int) 3210L),
  AuditSecurityEventType_SourceNode((int) 3211L),
  AuditSecurityEventType_SourceName((int) 3212L),
  AuditSecurityEventType_Time((int) 3213L),
  AuditSecurityEventType_ReceiveTime((int) 3214L),
  AuditSecurityEventType_LocalTime((int) 3215L),
  AuditSecurityEventType_Message((int) 3216L),
  AuditSecurityEventType_Severity((int) 3217L),
  AuditSecurityEventType_ActionTimeStamp((int) 3218L),
  AuditSecurityEventType_Status((int) 3219L),
  AuditSecurityEventType_ServerId((int) 3220L),
  AuditSecurityEventType_ClientAuditEntryId((int) 3221L),
  AuditSecurityEventType_ClientUserId((int) 3222L),
  AuditChannelEventType_EventId((int) 3223L),
  AuditChannelEventType_EventType((int) 3224L),
  AuditChannelEventType_SourceNode((int) 3225L),
  AuditChannelEventType_SourceName((int) 3226L),
  AuditChannelEventType_Time((int) 3227L),
  AuditChannelEventType_ReceiveTime((int) 3228L),
  AuditChannelEventType_LocalTime((int) 3229L),
  AuditChannelEventType_Message((int) 3230L),
  AuditChannelEventType_Severity((int) 3231L),
  AuditChannelEventType_ActionTimeStamp((int) 3232L),
  AuditChannelEventType_Status((int) 3233L),
  AuditChannelEventType_ServerId((int) 3234L),
  AuditChannelEventType_ClientAuditEntryId((int) 3235L),
  AuditChannelEventType_ClientUserId((int) 3236L),
  AuditOpenSecureChannelEventType_EventId((int) 3237L),
  AuditOpenSecureChannelEventType_EventType((int) 3238L),
  AuditOpenSecureChannelEventType_SourceNode((int) 3239L),
  AuditOpenSecureChannelEventType_SourceName((int) 3240L),
  AuditOpenSecureChannelEventType_Time((int) 3241L),
  AuditOpenSecureChannelEventType_ReceiveTime((int) 3242L),
  AuditOpenSecureChannelEventType_LocalTime((int) 3243L),
  AuditOpenSecureChannelEventType_Message((int) 3244L),
  AuditOpenSecureChannelEventType_Severity((int) 3245L),
  AuditOpenSecureChannelEventType_ActionTimeStamp((int) 3246L),
  AuditOpenSecureChannelEventType_Status((int) 3247L),
  AuditOpenSecureChannelEventType_ServerId((int) 3248L),
  AuditOpenSecureChannelEventType_ClientAuditEntryId((int) 3249L),
  AuditOpenSecureChannelEventType_ClientUserId((int) 3250L),
  AuditOpenSecureChannelEventType_SecureChannelId((int) 3251L),
  AuditSessionEventType_EventId((int) 3252L),
  AuditSessionEventType_EventType((int) 3253L),
  AuditSessionEventType_SourceNode((int) 3254L),
  AuditSessionEventType_SourceName((int) 3255L),
  AuditSessionEventType_Time((int) 3256L),
  AuditSessionEventType_ReceiveTime((int) 3257L),
  AuditSessionEventType_LocalTime((int) 3258L),
  AuditSessionEventType_Message((int) 3259L),
  AuditSessionEventType_Severity((int) 3260L),
  AuditSessionEventType_ActionTimeStamp((int) 3261L),
  AuditSessionEventType_Status((int) 3262L),
  AuditSessionEventType_ServerId((int) 3263L),
  AuditSessionEventType_ClientAuditEntryId((int) 3264L),
  AuditSessionEventType_ClientUserId((int) 3265L),
  AuditCreateSessionEventType_EventId((int) 3266L),
  AuditCreateSessionEventType_EventType((int) 3267L),
  AuditCreateSessionEventType_SourceNode((int) 3268L),
  AuditCreateSessionEventType_SourceName((int) 3269L),
  AuditCreateSessionEventType_Time((int) 3270L),
  AuditCreateSessionEventType_ReceiveTime((int) 3271L),
  AuditCreateSessionEventType_LocalTime((int) 3272L),
  AuditCreateSessionEventType_Message((int) 3273L),
  AuditCreateSessionEventType_Severity((int) 3274L),
  AuditCreateSessionEventType_ActionTimeStamp((int) 3275L),
  AuditCreateSessionEventType_Status((int) 3276L),
  AuditCreateSessionEventType_ServerId((int) 3277L),
  AuditCreateSessionEventType_ClientAuditEntryId((int) 3278L),
  AuditCreateSessionEventType_ClientUserId((int) 3279L),
  AuditUrlMismatchEventType_EventId((int) 3281L),
  AuditUrlMismatchEventType_EventType((int) 3282L),
  AuditUrlMismatchEventType_SourceNode((int) 3283L),
  AuditUrlMismatchEventType_SourceName((int) 3284L),
  AuditUrlMismatchEventType_Time((int) 3285L),
  AuditUrlMismatchEventType_ReceiveTime((int) 3286L),
  AuditUrlMismatchEventType_LocalTime((int) 3287L),
  AuditUrlMismatchEventType_Message((int) 3288L),
  AuditUrlMismatchEventType_Severity((int) 3289L),
  AuditUrlMismatchEventType_ActionTimeStamp((int) 3290L),
  AuditUrlMismatchEventType_Status((int) 3291L),
  AuditUrlMismatchEventType_ServerId((int) 3292L),
  AuditUrlMismatchEventType_ClientAuditEntryId((int) 3293L),
  AuditUrlMismatchEventType_ClientUserId((int) 3294L),
  AuditUrlMismatchEventType_SecureChannelId((int) 3296L),
  AuditUrlMismatchEventType_ClientCertificate((int) 3297L),
  AuditUrlMismatchEventType_ClientCertificateThumbprint((int) 3298L),
  AuditUrlMismatchEventType_RevisedSessionTimeout((int) 3299L),
  AuditActivateSessionEventType_EventId((int) 3300L),
  AuditActivateSessionEventType_EventType((int) 3301L),
  AuditActivateSessionEventType_SourceNode((int) 3302L),
  AuditActivateSessionEventType_SourceName((int) 3303L),
  AuditActivateSessionEventType_Time((int) 3304L),
  AuditActivateSessionEventType_ReceiveTime((int) 3305L),
  AuditActivateSessionEventType_LocalTime((int) 3306L),
  AuditActivateSessionEventType_Message((int) 3307L),
  AuditActivateSessionEventType_Severity((int) 3308L),
  AuditActivateSessionEventType_ActionTimeStamp((int) 3309L),
  AuditActivateSessionEventType_Status((int) 3310L),
  AuditActivateSessionEventType_ServerId((int) 3311L),
  AuditActivateSessionEventType_ClientAuditEntryId((int) 3312L),
  AuditActivateSessionEventType_ClientUserId((int) 3313L),
  AuditActivateSessionEventType_SessionId((int) 3314L),
  AuditCancelEventType_EventId((int) 3315L),
  AuditCancelEventType_EventType((int) 3316L),
  AuditCancelEventType_SourceNode((int) 3317L),
  AuditCancelEventType_SourceName((int) 3318L),
  AuditCancelEventType_Time((int) 3319L),
  AuditCancelEventType_ReceiveTime((int) 3320L),
  AuditCancelEventType_LocalTime((int) 3321L),
  AuditCancelEventType_Message((int) 3322L),
  AuditCancelEventType_Severity((int) 3323L),
  AuditCancelEventType_ActionTimeStamp((int) 3324L),
  AuditCancelEventType_Status((int) 3325L),
  AuditCancelEventType_ServerId((int) 3326L),
  AuditCancelEventType_ClientAuditEntryId((int) 3327L),
  AuditCancelEventType_ClientUserId((int) 3328L),
  AuditCancelEventType_SessionId((int) 3329L),
  AuditCertificateEventType_EventId((int) 3330L),
  AuditCertificateEventType_EventType((int) 3331L),
  AuditCertificateEventType_SourceNode((int) 3332L),
  AuditCertificateEventType_SourceName((int) 3333L),
  AuditCertificateEventType_Time((int) 3334L),
  AuditCertificateEventType_ReceiveTime((int) 3335L),
  AuditCertificateEventType_LocalTime((int) 3336L),
  AuditCertificateEventType_Message((int) 3337L),
  AuditCertificateEventType_Severity((int) 3338L),
  AuditCertificateEventType_ActionTimeStamp((int) 3339L),
  AuditCertificateEventType_Status((int) 3340L),
  AuditCertificateEventType_ServerId((int) 3341L),
  AuditCertificateEventType_ClientAuditEntryId((int) 3342L),
  AuditCertificateEventType_ClientUserId((int) 3343L),
  AuditCertificateDataMismatchEventType_EventId((int) 3344L),
  AuditCertificateDataMismatchEventType_EventType((int) 3345L),
  AuditCertificateDataMismatchEventType_SourceNode((int) 3346L),
  AuditCertificateDataMismatchEventType_SourceName((int) 3347L),
  AuditCertificateDataMismatchEventType_Time((int) 3348L),
  AuditCertificateDataMismatchEventType_ReceiveTime((int) 3349L),
  AuditCertificateDataMismatchEventType_LocalTime((int) 3350L),
  AuditCertificateDataMismatchEventType_Message((int) 3351L),
  AuditCertificateDataMismatchEventType_Severity((int) 3352L),
  AuditCertificateDataMismatchEventType_ActionTimeStamp((int) 3353L),
  AuditCertificateDataMismatchEventType_Status((int) 3354L),
  AuditCertificateDataMismatchEventType_ServerId((int) 3355L),
  AuditCertificateDataMismatchEventType_ClientAuditEntryId((int) 3356L),
  AuditCertificateDataMismatchEventType_ClientUserId((int) 3357L),
  AuditCertificateDataMismatchEventType_Certificate((int) 3358L),
  AuditCertificateExpiredEventType_EventId((int) 3359L),
  AuditCertificateExpiredEventType_EventType((int) 3360L),
  AuditCertificateExpiredEventType_SourceNode((int) 3361L),
  AuditCertificateExpiredEventType_SourceName((int) 3362L),
  AuditCertificateExpiredEventType_Time((int) 3363L),
  AuditCertificateExpiredEventType_ReceiveTime((int) 3364L),
  AuditCertificateExpiredEventType_LocalTime((int) 3365L),
  AuditCertificateExpiredEventType_Message((int) 3366L),
  AuditCertificateExpiredEventType_Severity((int) 3367L),
  AuditCertificateExpiredEventType_ActionTimeStamp((int) 3368L),
  AuditCertificateExpiredEventType_Status((int) 3369L),
  AuditCertificateExpiredEventType_ServerId((int) 3370L),
  AuditCertificateExpiredEventType_ClientAuditEntryId((int) 3371L),
  AuditCertificateExpiredEventType_ClientUserId((int) 3372L),
  AuditCertificateExpiredEventType_Certificate((int) 3373L),
  AuditCertificateInvalidEventType_EventId((int) 3374L),
  AuditCertificateInvalidEventType_EventType((int) 3375L),
  AuditCertificateInvalidEventType_SourceNode((int) 3376L),
  AuditCertificateInvalidEventType_SourceName((int) 3377L),
  AuditCertificateInvalidEventType_Time((int) 3378L),
  AuditCertificateInvalidEventType_ReceiveTime((int) 3379L),
  AuditCertificateInvalidEventType_LocalTime((int) 3380L),
  AuditCertificateInvalidEventType_Message((int) 3381L),
  AuditCertificateInvalidEventType_Severity((int) 3382L),
  AuditCertificateInvalidEventType_ActionTimeStamp((int) 3383L),
  AuditCertificateInvalidEventType_Status((int) 3384L),
  AuditCertificateInvalidEventType_ServerId((int) 3385L),
  AuditCertificateInvalidEventType_ClientAuditEntryId((int) 3386L),
  AuditCertificateInvalidEventType_ClientUserId((int) 3387L),
  AuditCertificateInvalidEventType_Certificate((int) 3388L),
  AuditCertificateUntrustedEventType_EventId((int) 3389L),
  AuditCertificateUntrustedEventType_EventType((int) 3390L),
  AuditCertificateUntrustedEventType_SourceNode((int) 3391L),
  AuditCertificateUntrustedEventType_SourceName((int) 3392L),
  AuditCertificateUntrustedEventType_Time((int) 3393L),
  AuditCertificateUntrustedEventType_ReceiveTime((int) 3394L),
  AuditCertificateUntrustedEventType_LocalTime((int) 3395L),
  AuditCertificateUntrustedEventType_Message((int) 3396L),
  AuditCertificateUntrustedEventType_Severity((int) 3397L),
  AuditCertificateUntrustedEventType_ActionTimeStamp((int) 3398L),
  AuditCertificateUntrustedEventType_Status((int) 3399L),
  AuditCertificateUntrustedEventType_ServerId((int) 3400L),
  AuditCertificateUntrustedEventType_ClientAuditEntryId((int) 3401L),
  AuditCertificateUntrustedEventType_ClientUserId((int) 3402L),
  AuditCertificateUntrustedEventType_Certificate((int) 3403L),
  AuditCertificateRevokedEventType_EventId((int) 3404L),
  AuditCertificateRevokedEventType_EventType((int) 3405L),
  AuditCertificateRevokedEventType_SourceNode((int) 3406L),
  AuditCertificateRevokedEventType_SourceName((int) 3407L),
  AuditCertificateRevokedEventType_Time((int) 3408L),
  AuditCertificateRevokedEventType_ReceiveTime((int) 3409L),
  AuditCertificateRevokedEventType_LocalTime((int) 3410L),
  AuditCertificateRevokedEventType_Message((int) 3411L),
  AuditCertificateRevokedEventType_Severity((int) 3412L),
  AuditCertificateRevokedEventType_ActionTimeStamp((int) 3413L),
  AuditCertificateRevokedEventType_Status((int) 3414L),
  AuditCertificateRevokedEventType_ServerId((int) 3415L),
  AuditCertificateRevokedEventType_ClientAuditEntryId((int) 3416L),
  AuditCertificateRevokedEventType_ClientUserId((int) 3417L),
  AuditCertificateRevokedEventType_Certificate((int) 3418L),
  AuditCertificateMismatchEventType_EventId((int) 3419L),
  AuditCertificateMismatchEventType_EventType((int) 3420L),
  AuditCertificateMismatchEventType_SourceNode((int) 3421L),
  AuditCertificateMismatchEventType_SourceName((int) 3422L),
  AuditCertificateMismatchEventType_Time((int) 3423L),
  AuditCertificateMismatchEventType_ReceiveTime((int) 3424L),
  AuditCertificateMismatchEventType_LocalTime((int) 3425L),
  AuditCertificateMismatchEventType_Message((int) 3426L),
  AuditCertificateMismatchEventType_Severity((int) 3427L),
  AuditCertificateMismatchEventType_ActionTimeStamp((int) 3428L),
  AuditCertificateMismatchEventType_Status((int) 3429L),
  AuditCertificateMismatchEventType_ServerId((int) 3430L),
  AuditCertificateMismatchEventType_ClientAuditEntryId((int) 3431L),
  AuditCertificateMismatchEventType_ClientUserId((int) 3432L),
  AuditCertificateMismatchEventType_Certificate((int) 3433L),
  AuditNodeManagementEventType_EventId((int) 3434L),
  AuditNodeManagementEventType_EventType((int) 3435L),
  AuditNodeManagementEventType_SourceNode((int) 3436L),
  AuditNodeManagementEventType_SourceName((int) 3437L),
  AuditNodeManagementEventType_Time((int) 3438L),
  AuditNodeManagementEventType_ReceiveTime((int) 3439L),
  AuditNodeManagementEventType_LocalTime((int) 3440L),
  AuditNodeManagementEventType_Message((int) 3441L),
  AuditNodeManagementEventType_Severity((int) 3442L),
  AuditNodeManagementEventType_ActionTimeStamp((int) 3443L),
  AuditNodeManagementEventType_Status((int) 3444L),
  AuditNodeManagementEventType_ServerId((int) 3445L),
  AuditNodeManagementEventType_ClientAuditEntryId((int) 3446L),
  AuditNodeManagementEventType_ClientUserId((int) 3447L),
  AuditAddNodesEventType_EventId((int) 3448L),
  AuditAddNodesEventType_EventType((int) 3449L),
  AuditAddNodesEventType_SourceNode((int) 3450L),
  AuditAddNodesEventType_SourceName((int) 3451L),
  AuditAddNodesEventType_Time((int) 3452L),
  AuditAddNodesEventType_ReceiveTime((int) 3453L),
  AuditAddNodesEventType_LocalTime((int) 3454L),
  AuditAddNodesEventType_Message((int) 3455L),
  AuditAddNodesEventType_Severity((int) 3456L),
  AuditAddNodesEventType_ActionTimeStamp((int) 3457L),
  AuditAddNodesEventType_Status((int) 3458L),
  AuditAddNodesEventType_ServerId((int) 3459L),
  AuditAddNodesEventType_ClientAuditEntryId((int) 3460L),
  AuditAddNodesEventType_ClientUserId((int) 3461L),
  AuditDeleteNodesEventType_EventId((int) 3462L),
  AuditDeleteNodesEventType_EventType((int) 3463L),
  AuditDeleteNodesEventType_SourceNode((int) 3464L),
  AuditDeleteNodesEventType_SourceName((int) 3465L),
  AuditDeleteNodesEventType_Time((int) 3466L),
  AuditDeleteNodesEventType_ReceiveTime((int) 3467L),
  AuditDeleteNodesEventType_LocalTime((int) 3468L),
  AuditDeleteNodesEventType_Message((int) 3469L),
  AuditDeleteNodesEventType_Severity((int) 3470L),
  AuditDeleteNodesEventType_ActionTimeStamp((int) 3471L),
  AuditDeleteNodesEventType_Status((int) 3472L),
  AuditDeleteNodesEventType_ServerId((int) 3473L),
  AuditDeleteNodesEventType_ClientAuditEntryId((int) 3474L),
  AuditDeleteNodesEventType_ClientUserId((int) 3475L),
  AuditAddReferencesEventType_EventId((int) 3476L),
  AuditAddReferencesEventType_EventType((int) 3477L),
  AuditAddReferencesEventType_SourceNode((int) 3478L),
  AuditAddReferencesEventType_SourceName((int) 3479L),
  AuditAddReferencesEventType_Time((int) 3480L),
  AuditAddReferencesEventType_ReceiveTime((int) 3481L),
  AuditAddReferencesEventType_LocalTime((int) 3482L),
  AuditAddReferencesEventType_Message((int) 3483L),
  AuditAddReferencesEventType_Severity((int) 3484L),
  AuditAddReferencesEventType_ActionTimeStamp((int) 3485L),
  AuditAddReferencesEventType_Status((int) 3486L),
  AuditAddReferencesEventType_ServerId((int) 3487L),
  AuditAddReferencesEventType_ClientAuditEntryId((int) 3488L),
  AuditAddReferencesEventType_ClientUserId((int) 3489L),
  AuditDeleteReferencesEventType_EventId((int) 3490L),
  AuditDeleteReferencesEventType_EventType((int) 3491L),
  AuditDeleteReferencesEventType_SourceNode((int) 3492L),
  AuditDeleteReferencesEventType_SourceName((int) 3493L),
  AuditDeleteReferencesEventType_Time((int) 3494L),
  AuditDeleteReferencesEventType_ReceiveTime((int) 3495L),
  AuditDeleteReferencesEventType_LocalTime((int) 3496L),
  AuditDeleteReferencesEventType_Message((int) 3497L),
  AuditDeleteReferencesEventType_Severity((int) 3498L),
  AuditDeleteReferencesEventType_ActionTimeStamp((int) 3499L),
  AuditDeleteReferencesEventType_Status((int) 3500L),
  AuditDeleteReferencesEventType_ServerId((int) 3501L),
  AuditDeleteReferencesEventType_ClientAuditEntryId((int) 3502L),
  AuditDeleteReferencesEventType_ClientUserId((int) 3503L),
  AuditUpdateEventType_EventId((int) 3504L),
  AuditUpdateEventType_EventType((int) 3505L),
  AuditUpdateEventType_SourceNode((int) 3506L),
  AuditUpdateEventType_SourceName((int) 3507L),
  AuditUpdateEventType_Time((int) 3508L),
  AuditUpdateEventType_ReceiveTime((int) 3509L),
  AuditUpdateEventType_LocalTime((int) 3510L),
  AuditUpdateEventType_Message((int) 3511L),
  AuditUpdateEventType_Severity((int) 3512L),
  AuditUpdateEventType_ActionTimeStamp((int) 3513L),
  AuditUpdateEventType_Status((int) 3514L),
  AuditUpdateEventType_ServerId((int) 3515L),
  AuditUpdateEventType_ClientAuditEntryId((int) 3516L),
  AuditUpdateEventType_ClientUserId((int) 3517L),
  AuditWriteUpdateEventType_EventId((int) 3518L),
  AuditWriteUpdateEventType_EventType((int) 3519L),
  AuditWriteUpdateEventType_SourceNode((int) 3520L),
  AuditWriteUpdateEventType_SourceName((int) 3521L),
  AuditWriteUpdateEventType_Time((int) 3522L),
  AuditWriteUpdateEventType_ReceiveTime((int) 3523L),
  AuditWriteUpdateEventType_LocalTime((int) 3524L),
  AuditWriteUpdateEventType_Message((int) 3525L),
  AuditWriteUpdateEventType_Severity((int) 3526L),
  AuditWriteUpdateEventType_ActionTimeStamp((int) 3527L),
  AuditWriteUpdateEventType_Status((int) 3528L),
  AuditWriteUpdateEventType_ServerId((int) 3529L),
  AuditWriteUpdateEventType_ClientAuditEntryId((int) 3530L),
  AuditWriteUpdateEventType_ClientUserId((int) 3531L),
  AuditHistoryUpdateEventType_EventId((int) 3532L),
  AuditHistoryUpdateEventType_EventType((int) 3533L),
  AuditHistoryUpdateEventType_SourceNode((int) 3534L),
  AuditHistoryUpdateEventType_SourceName((int) 3535L),
  AuditHistoryUpdateEventType_Time((int) 3536L),
  AuditHistoryUpdateEventType_ReceiveTime((int) 3537L),
  AuditHistoryUpdateEventType_LocalTime((int) 3538L),
  AuditHistoryUpdateEventType_Message((int) 3539L),
  AuditHistoryUpdateEventType_Severity((int) 3540L),
  AuditHistoryUpdateEventType_ActionTimeStamp((int) 3541L),
  AuditHistoryUpdateEventType_Status((int) 3542L),
  AuditHistoryUpdateEventType_ServerId((int) 3543L),
  AuditHistoryUpdateEventType_ClientAuditEntryId((int) 3544L),
  AuditHistoryUpdateEventType_ClientUserId((int) 3545L),
  AuditHistoryEventUpdateEventType_EventId((int) 3546L),
  AuditHistoryEventUpdateEventType_EventType((int) 3547L),
  AuditHistoryEventUpdateEventType_SourceNode((int) 3548L),
  AuditHistoryEventUpdateEventType_SourceName((int) 3549L),
  AuditHistoryEventUpdateEventType_Time((int) 3550L),
  AuditHistoryEventUpdateEventType_ReceiveTime((int) 3551L),
  AuditHistoryEventUpdateEventType_LocalTime((int) 3552L),
  AuditHistoryEventUpdateEventType_Message((int) 3553L),
  AuditHistoryEventUpdateEventType_Severity((int) 3554L),
  AuditHistoryEventUpdateEventType_ActionTimeStamp((int) 3555L),
  AuditHistoryEventUpdateEventType_Status((int) 3556L),
  AuditHistoryEventUpdateEventType_ServerId((int) 3557L),
  AuditHistoryEventUpdateEventType_ClientAuditEntryId((int) 3558L),
  AuditHistoryEventUpdateEventType_ClientUserId((int) 3559L),
  AuditHistoryEventUpdateEventType_ParameterDataTypeId((int) 3560L),
  AuditHistoryValueUpdateEventType_EventId((int) 3561L),
  AuditHistoryValueUpdateEventType_EventType((int) 3562L),
  AuditHistoryValueUpdateEventType_SourceNode((int) 3563L),
  AuditHistoryValueUpdateEventType_SourceName((int) 3564L),
  AuditHistoryValueUpdateEventType_Time((int) 3565L),
  AuditHistoryValueUpdateEventType_ReceiveTime((int) 3566L),
  AuditHistoryValueUpdateEventType_LocalTime((int) 3567L),
  AuditHistoryValueUpdateEventType_Message((int) 3568L),
  AuditHistoryValueUpdateEventType_Severity((int) 3569L),
  AuditHistoryValueUpdateEventType_ActionTimeStamp((int) 3570L),
  AuditHistoryValueUpdateEventType_Status((int) 3571L),
  AuditHistoryValueUpdateEventType_ServerId((int) 3572L),
  AuditHistoryValueUpdateEventType_ClientAuditEntryId((int) 3573L),
  AuditHistoryValueUpdateEventType_ClientUserId((int) 3574L),
  AuditHistoryValueUpdateEventType_ParameterDataTypeId((int) 3575L),
  AuditHistoryDeleteEventType_EventId((int) 3576L),
  AuditHistoryDeleteEventType_EventType((int) 3577L),
  AuditHistoryDeleteEventType_SourceNode((int) 3578L),
  AuditHistoryDeleteEventType_SourceName((int) 3579L),
  AuditHistoryDeleteEventType_Time((int) 3580L),
  AuditHistoryDeleteEventType_ReceiveTime((int) 3581L),
  AuditHistoryDeleteEventType_LocalTime((int) 3582L),
  AuditHistoryDeleteEventType_Message((int) 3583L),
  AuditHistoryDeleteEventType_Severity((int) 3584L),
  AuditHistoryDeleteEventType_ActionTimeStamp((int) 3585L),
  AuditHistoryDeleteEventType_Status((int) 3586L),
  AuditHistoryDeleteEventType_ServerId((int) 3587L),
  AuditHistoryDeleteEventType_ClientAuditEntryId((int) 3588L),
  AuditHistoryDeleteEventType_ClientUserId((int) 3589L),
  AuditHistoryDeleteEventType_ParameterDataTypeId((int) 3590L),
  AuditHistoryRawModifyDeleteEventType_EventId((int) 3591L),
  AuditHistoryRawModifyDeleteEventType_EventType((int) 3592L),
  AuditHistoryRawModifyDeleteEventType_SourceNode((int) 3593L),
  AuditHistoryRawModifyDeleteEventType_SourceName((int) 3594L),
  AuditHistoryRawModifyDeleteEventType_Time((int) 3595L),
  AuditHistoryRawModifyDeleteEventType_ReceiveTime((int) 3596L),
  AuditHistoryRawModifyDeleteEventType_LocalTime((int) 3597L),
  AuditHistoryRawModifyDeleteEventType_Message((int) 3598L),
  AuditHistoryRawModifyDeleteEventType_Severity((int) 3599L),
  AuditHistoryRawModifyDeleteEventType_ActionTimeStamp((int) 3600L),
  AuditHistoryRawModifyDeleteEventType_Status((int) 3601L),
  AuditHistoryRawModifyDeleteEventType_ServerId((int) 3602L),
  AuditHistoryRawModifyDeleteEventType_ClientAuditEntryId((int) 3603L),
  AuditHistoryRawModifyDeleteEventType_ClientUserId((int) 3604L),
  AuditHistoryRawModifyDeleteEventType_ParameterDataTypeId((int) 3605L),
  AuditHistoryRawModifyDeleteEventType_UpdatedNode((int) 3606L),
  AuditHistoryAtTimeDeleteEventType_EventId((int) 3607L),
  AuditHistoryAtTimeDeleteEventType_EventType((int) 3608L),
  AuditHistoryAtTimeDeleteEventType_SourceNode((int) 3609L),
  AuditHistoryAtTimeDeleteEventType_SourceName((int) 3610L),
  AuditHistoryAtTimeDeleteEventType_Time((int) 3611L),
  AuditHistoryAtTimeDeleteEventType_ReceiveTime((int) 3612L),
  AuditHistoryAtTimeDeleteEventType_LocalTime((int) 3613L),
  AuditHistoryAtTimeDeleteEventType_Message((int) 3614L),
  AuditHistoryAtTimeDeleteEventType_Severity((int) 3615L),
  AuditHistoryAtTimeDeleteEventType_ActionTimeStamp((int) 3616L),
  AuditHistoryAtTimeDeleteEventType_Status((int) 3617L),
  AuditHistoryAtTimeDeleteEventType_ServerId((int) 3618L),
  AuditHistoryAtTimeDeleteEventType_ClientAuditEntryId((int) 3619L),
  AuditHistoryAtTimeDeleteEventType_ClientUserId((int) 3620L),
  AuditHistoryAtTimeDeleteEventType_ParameterDataTypeId((int) 3621L),
  AuditHistoryAtTimeDeleteEventType_UpdatedNode((int) 3622L),
  AuditHistoryEventDeleteEventType_EventId((int) 3623L),
  AuditHistoryEventDeleteEventType_EventType((int) 3624L),
  AuditHistoryEventDeleteEventType_SourceNode((int) 3625L),
  AuditHistoryEventDeleteEventType_SourceName((int) 3626L),
  AuditHistoryEventDeleteEventType_Time((int) 3627L),
  AuditHistoryEventDeleteEventType_ReceiveTime((int) 3628L),
  AuditHistoryEventDeleteEventType_LocalTime((int) 3629L),
  AuditHistoryEventDeleteEventType_Message((int) 3630L),
  AuditHistoryEventDeleteEventType_Severity((int) 3631L),
  AuditHistoryEventDeleteEventType_ActionTimeStamp((int) 3632L),
  AuditHistoryEventDeleteEventType_Status((int) 3633L),
  AuditHistoryEventDeleteEventType_ServerId((int) 3634L),
  AuditHistoryEventDeleteEventType_ClientAuditEntryId((int) 3635L),
  AuditHistoryEventDeleteEventType_ClientUserId((int) 3636L),
  AuditHistoryEventDeleteEventType_ParameterDataTypeId((int) 3637L),
  AuditHistoryEventDeleteEventType_UpdatedNode((int) 3638L),
  AuditUpdateMethodEventType_EventId((int) 3639L),
  AuditUpdateMethodEventType_EventType((int) 3640L),
  AuditUpdateMethodEventType_SourceNode((int) 3641L),
  AuditUpdateMethodEventType_SourceName((int) 3642L),
  AuditUpdateMethodEventType_Time((int) 3643L),
  AuditUpdateMethodEventType_ReceiveTime((int) 3644L),
  AuditUpdateMethodEventType_LocalTime((int) 3645L),
  AuditUpdateMethodEventType_Message((int) 3646L),
  AuditUpdateMethodEventType_Severity((int) 3647L),
  AuditUpdateMethodEventType_ActionTimeStamp((int) 3648L),
  AuditUpdateMethodEventType_Status((int) 3649L),
  AuditUpdateMethodEventType_ServerId((int) 3650L),
  AuditUpdateMethodEventType_ClientAuditEntryId((int) 3651L),
  AuditUpdateMethodEventType_ClientUserId((int) 3652L),
  AuditUpdateStateEventType_EventId((int) 3758L),
  AuditUpdateStateEventType_EventType((int) 3759L),
  AuditUpdateStateEventType_SourceNode((int) 3760L),
  AuditUpdateStateEventType_SourceName((int) 3761L),
  AuditUpdateStateEventType_Time((int) 3762L),
  AuditUpdateStateEventType_ReceiveTime((int) 3763L),
  AuditUpdateStateEventType_LocalTime((int) 3764L),
  AuditUpdateStateEventType_Message((int) 3765L),
  AuditUpdateStateEventType_Severity((int) 3766L),
  AuditUpdateStateEventType_ActionTimeStamp((int) 3767L),
  AuditUpdateStateEventType_Status((int) 3768L),
  AuditUpdateStateEventType_ServerId((int) 3769L),
  AuditUpdateStateEventType_ClientAuditEntryId((int) 3770L),
  AuditUpdateStateEventType_ClientUserId((int) 3771L),
  AuditUpdateStateEventType_MethodId((int) 3772L),
  AuditUpdateStateEventType_InputArguments((int) 3773L),
  AuditConditionEventType_EventId((int) 3996L),
  AuditConditionEventType_EventType((int) 3997L),
  AuditConditionEventType_SourceNode((int) 3998L),
  AuditConditionEventType_SourceName((int) 3999L),
  AuditConditionEventType_Time((int) 4000L),
  AuditConditionEventType_ReceiveTime((int) 4001L),
  AuditConditionEventType_LocalTime((int) 4002L),
  AuditConditionEventType_Message((int) 4003L),
  AuditConditionEventType_Severity((int) 4004L),
  AuditConditionEventType_ActionTimeStamp((int) 4005L),
  AuditConditionEventType_Status((int) 4006L),
  AuditConditionEventType_ServerId((int) 4007L),
  AuditConditionEventType_ClientAuditEntryId((int) 4008L),
  AuditConditionEventType_ClientUserId((int) 4009L),
  AuditConditionEventType_MethodId((int) 4010L),
  AuditConditionEventType_InputArguments((int) 4011L),
  AuditConditionEnableEventType_EventId((int) 4106L),
  AuditConditionEnableEventType_EventType((int) 4107L),
  AuditConditionEnableEventType_SourceNode((int) 4108L),
  AuditConditionEnableEventType_SourceName((int) 4109L),
  AuditConditionEnableEventType_Time((int) 4110L),
  AuditConditionEnableEventType_ReceiveTime((int) 4111L),
  AuditConditionEnableEventType_LocalTime((int) 4112L),
  AuditConditionEnableEventType_Message((int) 4113L),
  AuditConditionEnableEventType_Severity((int) 4114L),
  AuditConditionEnableEventType_ActionTimeStamp((int) 4115L),
  AuditConditionEnableEventType_Status((int) 4116L),
  AuditConditionEnableEventType_ServerId((int) 4117L),
  AuditConditionEnableEventType_ClientAuditEntryId((int) 4118L),
  AuditConditionEnableEventType_ClientUserId((int) 4119L),
  AuditConditionEnableEventType_MethodId((int) 4120L),
  AuditConditionEnableEventType_InputArguments((int) 4121L),
  AuditConditionCommentEventType_EventId((int) 4170L),
  AuditConditionCommentEventType_EventType((int) 4171L),
  AuditConditionCommentEventType_SourceNode((int) 4172L),
  AuditConditionCommentEventType_SourceName((int) 4173L),
  AuditConditionCommentEventType_Time((int) 4174L),
  AuditConditionCommentEventType_ReceiveTime((int) 4175L),
  AuditConditionCommentEventType_LocalTime((int) 4176L),
  AuditConditionCommentEventType_Message((int) 4177L),
  AuditConditionCommentEventType_Severity((int) 4178L),
  AuditConditionCommentEventType_ActionTimeStamp((int) 4179L),
  AuditConditionCommentEventType_Status((int) 4180L),
  AuditConditionCommentEventType_ServerId((int) 4181L),
  AuditConditionCommentEventType_ClientAuditEntryId((int) 4182L),
  AuditConditionCommentEventType_ClientUserId((int) 4183L),
  AuditConditionCommentEventType_MethodId((int) 4184L),
  AuditConditionCommentEventType_InputArguments((int) 4185L),
  AuditConditionRespondEventType_EventId((int) 8928L),
  AuditConditionRespondEventType_EventType((int) 8929L),
  AuditConditionRespondEventType_SourceNode((int) 8930L),
  AuditConditionRespondEventType_SourceName((int) 8931L),
  AuditConditionRespondEventType_Time((int) 8932L),
  AuditConditionRespondEventType_ReceiveTime((int) 8933L),
  AuditConditionRespondEventType_LocalTime((int) 8934L),
  AuditConditionRespondEventType_Message((int) 8935L),
  AuditConditionRespondEventType_Severity((int) 8936L),
  AuditConditionRespondEventType_ActionTimeStamp((int) 8937L),
  AuditConditionRespondEventType_Status((int) 8938L),
  AuditConditionRespondEventType_ServerId((int) 8939L),
  AuditConditionRespondEventType_ClientAuditEntryId((int) 8940L),
  AuditConditionRespondEventType_ClientUserId((int) 8941L),
  AuditConditionRespondEventType_MethodId((int) 8942L),
  AuditConditionRespondEventType_InputArguments((int) 8943L),
  AuditConditionAcknowledgeEventType_EventId((int) 8945L),
  AuditConditionAcknowledgeEventType_EventType((int) 8946L),
  AuditConditionAcknowledgeEventType_SourceNode((int) 8947L),
  AuditConditionAcknowledgeEventType_SourceName((int) 8948L),
  AuditConditionAcknowledgeEventType_Time((int) 8949L),
  AuditConditionAcknowledgeEventType_ReceiveTime((int) 8950L),
  AuditConditionAcknowledgeEventType_LocalTime((int) 8951L),
  AuditConditionAcknowledgeEventType_Message((int) 8952L),
  AuditConditionAcknowledgeEventType_Severity((int) 8953L),
  AuditConditionAcknowledgeEventType_ActionTimeStamp((int) 8954L),
  AuditConditionAcknowledgeEventType_Status((int) 8955L),
  AuditConditionAcknowledgeEventType_ServerId((int) 8956L),
  AuditConditionAcknowledgeEventType_ClientAuditEntryId((int) 8957L),
  AuditConditionAcknowledgeEventType_ClientUserId((int) 8958L),
  AuditConditionAcknowledgeEventType_MethodId((int) 8959L),
  AuditConditionAcknowledgeEventType_InputArguments((int) 8960L),
  AuditConditionConfirmEventType_EventId((int) 8962L),
  AuditConditionConfirmEventType_EventType((int) 8963L),
  AuditConditionConfirmEventType_SourceNode((int) 8964L),
  AuditConditionConfirmEventType_SourceName((int) 8965L),
  AuditConditionConfirmEventType_Time((int) 8966L),
  AuditConditionConfirmEventType_ReceiveTime((int) 8967L),
  AuditConditionConfirmEventType_LocalTime((int) 8968L),
  AuditConditionConfirmEventType_Message((int) 8969L),
  AuditConditionConfirmEventType_Severity((int) 8970L),
  AuditConditionConfirmEventType_ActionTimeStamp((int) 8971L),
  AuditConditionConfirmEventType_Status((int) 8972L),
  AuditConditionConfirmEventType_ServerId((int) 8973L),
  AuditConditionConfirmEventType_ClientAuditEntryId((int) 8974L),
  AuditConditionConfirmEventType_ClientUserId((int) 8975L),
  AuditConditionConfirmEventType_MethodId((int) 8976L),
  AuditConditionConfirmEventType_InputArguments((int) 8977L),
  AuditConditionShelvingEventType_EventId((int) 11094L),
  AuditConditionShelvingEventType_EventType((int) 11095L),
  AuditConditionShelvingEventType_SourceNode((int) 11096L),
  AuditConditionShelvingEventType_SourceName((int) 11097L),
  AuditConditionShelvingEventType_Time((int) 11098L),
  AuditConditionShelvingEventType_ReceiveTime((int) 11099L),
  AuditConditionShelvingEventType_LocalTime((int) 11100L),
  AuditConditionShelvingEventType_Message((int) 11101L),
  AuditConditionShelvingEventType_Severity((int) 11102L),
  AuditConditionShelvingEventType_ActionTimeStamp((int) 11103L),
  AuditConditionShelvingEventType_Status((int) 11104L),
  AuditConditionShelvingEventType_ServerId((int) 11105L),
  AuditConditionShelvingEventType_ClientAuditEntryId((int) 11106L),
  AuditConditionShelvingEventType_ClientUserId((int) 11107L),
  AuditConditionShelvingEventType_MethodId((int) 11108L),
  AuditConditionShelvingEventType_InputArguments((int) 11109L),
  AuditActivateSessionEventType_SecureChannelId((int) 11485L),
  AuditConditionCommentEventType_Comment((int) 11851L),
  AuditConditionRespondEventType_SelectedResponse((int) 11852L),
  AuditConditionAcknowledgeEventType_Comment((int) 11853L),
  AuditConditionConfirmEventType_Comment((int) 11854L),
  AuditConditionShelvingEventType_ShelvingTime((int) 11855L),
  AuditProgramTransitionEventType_EventId((int) 11857L),
  AuditProgramTransitionEventType_EventType((int) 11858L),
  AuditProgramTransitionEventType_SourceNode((int) 11859L),
  AuditProgramTransitionEventType_SourceName((int) 11860L),
  AuditProgramTransitionEventType_Time((int) 11861L),
  AuditProgramTransitionEventType_ReceiveTime((int) 11862L),
  AuditProgramTransitionEventType_LocalTime((int) 11863L),
  AuditProgramTransitionEventType_Message((int) 11864L),
  AuditProgramTransitionEventType_Severity((int) 11865L),
  AuditProgramTransitionEventType_ActionTimeStamp((int) 11866L),
  AuditProgramTransitionEventType_Status((int) 11867L),
  AuditProgramTransitionEventType_ServerId((int) 11868L),
  AuditProgramTransitionEventType_ClientAuditEntryId((int) 11869L),
  AuditProgramTransitionEventType_ClientUserId((int) 11870L),
  AuditProgramTransitionEventType_MethodId((int) 11871L),
  AuditProgramTransitionEventType_InputArguments((int) 11872L),
  AuditProgramTransitionEventType_OldStateId((int) 11873L),
  AuditProgramTransitionEventType_NewStateId((int) 11874L),
  AuditProgramTransitionEventType_TransitionNumber((int) 11875L),
  AuditCreateSessionEventType_SessionId((int) 14413L),
  AuditUrlMismatchEventType_SessionId((int) 14414L),
  AuditConditionResetEventType_EventId((int) 15014L),
  AuditConditionResetEventType_EventType((int) 15015L),
  AuditConditionResetEventType_SourceNode((int) 15016L),
  AuditConditionResetEventType_SourceName((int) 15017L),
  AuditConditionResetEventType_Time((int) 15018L),
  AuditConditionResetEventType_ReceiveTime((int) 15019L),
  AuditConditionResetEventType_LocalTime((int) 15020L),
  AuditConditionResetEventType_Message((int) 15021L),
  AuditConditionResetEventType_Severity((int) 15022L),
  AuditConditionResetEventType_ActionTimeStamp((int) 15023L),
  AuditConditionResetEventType_Status((int) 15024L),
  AuditConditionResetEventType_ServerId((int) 15025L),
  AuditConditionResetEventType_ClientAuditEntryId((int) 15026L),
  AuditConditionResetEventType_ClientUserId((int) 15027L),
  AuditConditionResetEventType_MethodId((int) 15028L),
  AuditConditionResetEventType_InputArguments((int) 15029L),
  AuditConditionCommentEventType_ConditionEventId((int) 17222L),
  AuditConditionAcknowledgeEventType_ConditionEventId((int) 17223L),
  AuditConditionConfirmEventType_ConditionEventId((int) 17224L),
  AuditConditionSuppressionEventType_EventId((int) 17226L),
  AuditConditionSuppressionEventType_EventType((int) 17227L),
  AuditConditionSuppressionEventType_SourceNode((int) 17228L),
  AuditConditionSuppressionEventType_SourceName((int) 17229L),
  AuditConditionSuppressionEventType_Time((int) 17230L),
  AuditConditionSuppressionEventType_ReceiveTime((int) 17231L),
  AuditConditionSuppressionEventType_LocalTime((int) 17232L),
  AuditConditionSuppressionEventType_Message((int) 17233L),
  AuditConditionSuppressionEventType_Severity((int) 17234L),
  AuditConditionSuppressionEventType_ActionTimeStamp((int) 17235L),
  AuditConditionSuppressionEventType_Status((int) 17236L),
  AuditConditionSuppressionEventType_ServerId((int) 17237L),
  AuditConditionSuppressionEventType_ClientAuditEntryId((int) 17238L),
  AuditConditionSuppressionEventType_ClientUserId((int) 17239L),
  AuditConditionSuppressionEventType_MethodId((int) 17240L),
  AuditConditionSuppressionEventType_InputArguments((int) 17241L),
  AuditConditionSilenceEventType_EventId((int) 17243L),
  AuditConditionSilenceEventType_EventType((int) 17244L),
  AuditConditionSilenceEventType_SourceNode((int) 17245L),
  AuditConditionSilenceEventType_SourceName((int) 17246L),
  AuditConditionSilenceEventType_Time((int) 17247L),
  AuditConditionSilenceEventType_ReceiveTime((int) 17248L),
  AuditConditionSilenceEventType_LocalTime((int) 17249L),
  AuditConditionSilenceEventType_Message((int) 17250L),
  AuditConditionSilenceEventType_Severity((int) 17251L),
  AuditConditionSilenceEventType_ActionTimeStamp((int) 17252L),
  AuditConditionSilenceEventType_Status((int) 17253L),
  AuditConditionSilenceEventType_ServerId((int) 17254L),
  AuditConditionSilenceEventType_ClientAuditEntryId((int) 17255L),
  AuditConditionSilenceEventType_ClientUserId((int) 17256L),
  AuditConditionSilenceEventType_MethodId((int) 17257L),
  AuditConditionSilenceEventType_InputArguments((int) 17258L),
  AuditConditionOutOfServiceEventType_EventId((int) 17260L),
  AuditConditionOutOfServiceEventType_EventType((int) 17261L),
  AuditConditionOutOfServiceEventType_SourceNode((int) 17262L),
  AuditConditionOutOfServiceEventType_SourceName((int) 17263L),
  AuditConditionOutOfServiceEventType_Time((int) 17264L),
  AuditConditionOutOfServiceEventType_ReceiveTime((int) 17265L),
  AuditConditionOutOfServiceEventType_LocalTime((int) 17266L),
  AuditConditionOutOfServiceEventType_Message((int) 17267L),
  AuditConditionOutOfServiceEventType_Severity((int) 17268L),
  AuditConditionOutOfServiceEventType_ActionTimeStamp((int) 17269L),
  AuditConditionOutOfServiceEventType_Status((int) 17270L),
  AuditConditionOutOfServiceEventType_ServerId((int) 17271L),
  AuditConditionOutOfServiceEventType_ClientAuditEntryId((int) 17272L),
  AuditConditionOutOfServiceEventType_ClientUserId((int) 17273L),
  AuditConditionOutOfServiceEventType_MethodId((int) 17274L),
  AuditConditionOutOfServiceEventType_InputArguments((int) 17275L),
  AuditSecurityEventType_StatusCodeId((int) 17615L),
  AuditChannelEventType_StatusCodeId((int) 17616L),
  AuditOpenSecureChannelEventType_StatusCodeId((int) 17617L),
  AuditSessionEventType_StatusCodeId((int) 17618L),
  AuditCreateSessionEventType_StatusCodeId((int) 17619L),
  AuditUrlMismatchEventType_StatusCodeId((int) 17620L),
  AuditActivateSessionEventType_StatusCodeId((int) 17621L),
  AuditCancelEventType_StatusCodeId((int) 17622L),
  AuditCertificateEventType_StatusCodeId((int) 17623L),
  AuditCertificateDataMismatchEventType_StatusCodeId((int) 17624L),
  AuditCertificateExpiredEventType_StatusCodeId((int) 17625L),
  AuditCertificateInvalidEventType_StatusCodeId((int) 17626L),
  AuditCertificateUntrustedEventType_StatusCodeId((int) 17627L),
  AuditCertificateRevokedEventType_StatusCodeId((int) 17628L),
  AuditCertificateMismatchEventType_StatusCodeId((int) 17629L),
  AuditHistoryAnnotationUpdateEventType_EventId((int) 19096L),
  AuditHistoryAnnotationUpdateEventType_EventType((int) 19097L),
  AuditHistoryAnnotationUpdateEventType_SourceNode((int) 19098L),
  AuditHistoryAnnotationUpdateEventType_SourceName((int) 19099L),
  AuditHistoryAnnotationUpdateEventType_Time((int) 19100L),
  AuditHistoryAnnotationUpdateEventType_ReceiveTime((int) 19101L),
  AuditHistoryAnnotationUpdateEventType_LocalTime((int) 19102L),
  AuditHistoryAnnotationUpdateEventType_Message((int) 19103L),
  AuditHistoryAnnotationUpdateEventType_Severity((int) 19104L),
  AuditHistoryAnnotationUpdateEventType_ActionTimeStamp((int) 19105L),
  AuditHistoryAnnotationUpdateEventType_Status((int) 19106L),
  AuditHistoryAnnotationUpdateEventType_ServerId((int) 19289L),
  AuditHistoryAnnotationUpdateEventType_ClientAuditEntryId((int) 19290L),
  AuditHistoryAnnotationUpdateEventType_ClientUserId((int) 19291L),
  AuditHistoryAnnotationUpdateEventType_ParameterDataTypeId((int) 19292L),
  AuditHistoryAnnotationUpdateEventType_PerformInsertReplace((int) 19293L),
  AuditHistoryAnnotationUpdateEventType_NewValues((int) 19294L),
  AuditHistoryAnnotationUpdateEventType_OldValues((int) 19295L),
  AuditClientEventType_EventId((int) 23607L),
  AuditClientEventType_EventType((int) 23610L),
  AuditClientEventType_SourceNode((int) 23611L),
  AuditClientEventType_SourceName((int) 23891L),
  AuditClientEventType_Time((int) 23892L),
  AuditClientEventType_ReceiveTime((int) 23893L),
  AuditClientEventType_LocalTime((int) 23894L),
  AuditClientEventType_Message((int) 23895L),
  AuditClientEventType_Severity((int) 23896L),
  AuditClientEventType_ActionTimeStamp((int) 23903L),
  AuditClientEventType_Status((int) 23904L),
  AuditClientEventType_ServerId((int) 23905L),
  AuditClientEventType_ClientAuditEntryId((int) 23906L),
  AuditClientEventType_ClientUserId((int) 23907L),
  AuditClientEventType_ServerUri((int) 23908L),
  AuditClientUpdateMethodResultEventType_EventId((int) 23927L),
  AuditClientUpdateMethodResultEventType_EventType((int) 23930L),
  AuditClientUpdateMethodResultEventType_SourceNode((int) 23931L),
  AuditClientUpdateMethodResultEventType_SourceName((int) 23959L),
  AuditClientUpdateMethodResultEventType_Time((int) 23960L),
  AuditClientUpdateMethodResultEventType_ReceiveTime((int) 23961L),
  AuditClientUpdateMethodResultEventType_LocalTime((int) 23962L),
  AuditClientUpdateMethodResultEventType_Message((int) 23963L),
  AuditClientUpdateMethodResultEventType_Severity((int) 23964L),
  AuditClientUpdateMethodResultEventType_ActionTimeStamp((int) 23971L),
  AuditClientUpdateMethodResultEventType_Status((int) 23972L),
  AuditClientUpdateMethodResultEventType_ServerId((int) 23973L),
  AuditClientUpdateMethodResultEventType_ClientAuditEntryId((int) 23974L),
  AuditClientUpdateMethodResultEventType_ClientUserId((int) 23975L),
  AuditClientUpdateMethodResultEventType_ServerUri((int) 23976L),
  AuditClientUpdateMethodResultEventType_ObjectId((int) 23994L),
  AuditClientUpdateMethodResultEventType_MethodId((int) 23995L),
  AuditClientUpdateMethodResultEventType_StatusCodeId((int) 23998L),
  AuditClientUpdateMethodResultEventType_InputArguments((int) 23999L),
  AuditOpenSecureChannelEventType_CertificateErrorEventId((int) 24135L),
  AuditClientUpdateMethodResultEventType_OutputArguments((int) 25684L),
  AuditEventType_ConditionClassId((int) 31775L),
  AuditEventType_ConditionClassName((int) 31776L),
  AuditEventType_ConditionSubClassId((int) 31777L),
  AuditEventType_ConditionSubClassName((int) 31778L),
  AuditSecurityEventType_ConditionClassId((int) 31779L),
  AuditSecurityEventType_ConditionClassName((int) 31780L),
  AuditSecurityEventType_ConditionSubClassId((int) 31781L),
  AuditSecurityEventType_ConditionSubClassName((int) 31782L),
  AuditChannelEventType_ConditionClassId((int) 31783L),
  AuditChannelEventType_ConditionClassName((int) 31784L),
  AuditChannelEventType_ConditionSubClassId((int) 31785L),
  AuditChannelEventType_ConditionSubClassName((int) 31786L),
  AuditOpenSecureChannelEventType_ConditionClassId((int) 31787L),
  AuditOpenSecureChannelEventType_ConditionClassName((int) 31788L),
  AuditOpenSecureChannelEventType_ConditionSubClassId((int) 31789L),
  AuditOpenSecureChannelEventType_ConditionSubClassName((int) 31790L),
  AuditSessionEventType_ConditionClassId((int) 31791L),
  AuditSessionEventType_ConditionClassName((int) 31792L),
  AuditSessionEventType_ConditionSubClassId((int) 31793L),
  AuditSessionEventType_ConditionSubClassName((int) 31794L),
  AuditCreateSessionEventType_ConditionClassId((int) 31795L),
  AuditCreateSessionEventType_ConditionClassName((int) 31796L),
  AuditCreateSessionEventType_ConditionSubClassId((int) 31797L),
  AuditCreateSessionEventType_ConditionSubClassName((int) 31798L),
  AuditUrlMismatchEventType_ConditionClassId((int) 31799L),
  AuditUrlMismatchEventType_ConditionClassName((int) 31800L),
  AuditUrlMismatchEventType_ConditionSubClassId((int) 31801L),
  AuditUrlMismatchEventType_ConditionSubClassName((int) 31802L),
  AuditActivateSessionEventType_ConditionClassId((int) 31803L),
  AuditActivateSessionEventType_ConditionClassName((int) 31804L),
  AuditActivateSessionEventType_ConditionSubClassId((int) 31805L),
  AuditActivateSessionEventType_ConditionSubClassName((int) 31806L),
  AuditCancelEventType_ConditionClassId((int) 31807L),
  AuditCancelEventType_ConditionClassName((int) 31808L),
  AuditCancelEventType_ConditionSubClassId((int) 31809L),
  AuditCancelEventType_ConditionSubClassName((int) 31810L),
  AuditCertificateEventType_ConditionClassId((int) 31811L),
  AuditCertificateEventType_ConditionClassName((int) 31812L),
  AuditCertificateEventType_ConditionSubClassId((int) 31813L),
  AuditCertificateEventType_ConditionSubClassName((int) 31814L),
  AuditCertificateDataMismatchEventType_ConditionClassId((int) 31815L),
  AuditCertificateDataMismatchEventType_ConditionClassName((int) 31816L),
  AuditCertificateDataMismatchEventType_ConditionSubClassId((int) 31817L),
  AuditCertificateDataMismatchEventType_ConditionSubClassName((int) 31818L),
  AuditCertificateExpiredEventType_ConditionClassId((int) 31819L),
  AuditCertificateExpiredEventType_ConditionClassName((int) 31820L),
  AuditCertificateExpiredEventType_ConditionSubClassId((int) 31821L),
  AuditCertificateExpiredEventType_ConditionSubClassName((int) 31822L),
  AuditCertificateInvalidEventType_ConditionClassId((int) 31823L),
  AuditCertificateInvalidEventType_ConditionClassName((int) 31824L),
  AuditCertificateInvalidEventType_ConditionSubClassId((int) 31825L),
  AuditCertificateInvalidEventType_ConditionSubClassName((int) 31826L),
  AuditCertificateUntrustedEventType_ConditionClassId((int) 31827L),
  AuditCertificateUntrustedEventType_ConditionClassName((int) 31828L),
  AuditCertificateUntrustedEventType_ConditionSubClassId((int) 31829L),
  AuditCertificateUntrustedEventType_ConditionSubClassName((int) 31830L),
  AuditCertificateRevokedEventType_ConditionClassId((int) 31831L),
  AuditCertificateRevokedEventType_ConditionClassName((int) 31832L),
  AuditCertificateRevokedEventType_ConditionSubClassId((int) 31833L),
  AuditCertificateRevokedEventType_ConditionSubClassName((int) 31834L),
  AuditCertificateMismatchEventType_ConditionClassId((int) 31835L),
  AuditCertificateMismatchEventType_ConditionClassName((int) 31836L),
  AuditCertificateMismatchEventType_ConditionSubClassId((int) 31837L),
  AuditCertificateMismatchEventType_ConditionSubClassName((int) 31838L),
  AuditNodeManagementEventType_ConditionClassId((int) 31839L),
  AuditNodeManagementEventType_ConditionClassName((int) 31840L),
  AuditNodeManagementEventType_ConditionSubClassId((int) 31841L),
  AuditNodeManagementEventType_ConditionSubClassName((int) 31842L),
  AuditAddNodesEventType_ConditionClassId((int) 31843L),
  AuditAddNodesEventType_ConditionClassName((int) 31844L),
  AuditAddNodesEventType_ConditionSubClassId((int) 31845L),
  AuditAddNodesEventType_ConditionSubClassName((int) 31846L),
  AuditDeleteNodesEventType_ConditionClassId((int) 31847L),
  AuditDeleteNodesEventType_ConditionClassName((int) 31848L),
  AuditDeleteNodesEventType_ConditionSubClassId((int) 31849L),
  AuditDeleteNodesEventType_ConditionSubClassName((int) 31850L),
  AuditAddReferencesEventType_ConditionClassId((int) 31851L),
  AuditAddReferencesEventType_ConditionClassName((int) 31852L),
  AuditAddReferencesEventType_ConditionSubClassId((int) 31853L),
  AuditAddReferencesEventType_ConditionSubClassName((int) 31854L),
  AuditDeleteReferencesEventType_ConditionClassId((int) 31855L),
  AuditDeleteReferencesEventType_ConditionClassName((int) 31856L),
  AuditDeleteReferencesEventType_ConditionSubClassId((int) 31857L),
  AuditDeleteReferencesEventType_ConditionSubClassName((int) 31858L),
  AuditUpdateEventType_ConditionClassId((int) 31859L),
  AuditUpdateEventType_ConditionClassName((int) 31860L),
  AuditUpdateEventType_ConditionSubClassId((int) 31861L),
  AuditUpdateEventType_ConditionSubClassName((int) 31862L),
  AuditWriteUpdateEventType_ConditionClassId((int) 31863L),
  AuditWriteUpdateEventType_ConditionClassName((int) 31864L),
  AuditWriteUpdateEventType_ConditionSubClassId((int) 31865L),
  AuditWriteUpdateEventType_ConditionSubClassName((int) 31866L),
  AuditHistoryUpdateEventType_ConditionClassId((int) 31867L),
  AuditHistoryUpdateEventType_ConditionClassName((int) 31868L),
  AuditHistoryUpdateEventType_ConditionSubClassId((int) 31869L),
  AuditHistoryUpdateEventType_ConditionSubClassName((int) 31870L),
  AuditUpdateMethodEventType_ConditionClassId((int) 31871L),
  AuditUpdateMethodEventType_ConditionClassName((int) 31872L),
  AuditUpdateMethodEventType_ConditionSubClassId((int) 31873L),
  AuditUpdateMethodEventType_ConditionSubClassName((int) 31874L),
  AuditClientEventType_ConditionClassId((int) 31907L),
  AuditClientEventType_ConditionClassName((int) 31908L),
  AuditClientEventType_ConditionSubClassId((int) 31909L),
  AuditClientEventType_ConditionSubClassName((int) 31910L),
  AuditClientUpdateMethodResultEventType_ConditionClassId((int) 31911L),
  AuditClientUpdateMethodResultEventType_ConditionClassName((int) 31912L),
  AuditClientUpdateMethodResultEventType_ConditionSubClassId((int) 31913L),
  AuditClientUpdateMethodResultEventType_ConditionSubClassName((int) 31914L),
  AuditUpdateStateEventType_ConditionClassId((int) 31923L),
  AuditUpdateStateEventType_ConditionClassName((int) 31924L),
  AuditUpdateStateEventType_ConditionSubClassId((int) 31925L),
  AuditUpdateStateEventType_ConditionSubClassName((int) 31926L),
  AuditConditionEventType_ConditionClassId((int) 31931L),
  AuditConditionEventType_ConditionClassName((int) 31932L),
  AuditConditionEventType_ConditionSubClassId((int) 31933L),
  AuditConditionEventType_ConditionSubClassName((int) 31934L),
  AuditConditionEnableEventType_ConditionClassId((int) 31935L),
  AuditConditionEnableEventType_ConditionClassName((int) 31936L),
  AuditConditionEnableEventType_ConditionSubClassId((int) 31937L),
  AuditConditionEnableEventType_ConditionSubClassName((int) 31938L),
  AuditConditionCommentEventType_ConditionClassId((int) 31939L),
  AuditConditionCommentEventType_ConditionClassName((int) 31940L),
  AuditConditionCommentEventType_ConditionSubClassId((int) 31941L),
  AuditConditionCommentEventType_ConditionSubClassName((int) 31942L),
  AuditConditionRespondEventType_ConditionClassId((int) 31943L),
  AuditConditionRespondEventType_ConditionClassName((int) 31944L),
  AuditConditionRespondEventType_ConditionSubClassId((int) 31945L),
  AuditConditionRespondEventType_ConditionSubClassName((int) 31946L),
  AuditConditionAcknowledgeEventType_ConditionClassId((int) 31947L),
  AuditConditionAcknowledgeEventType_ConditionClassName((int) 31948L),
  AuditConditionAcknowledgeEventType_ConditionSubClassId((int) 31949L),
  AuditConditionAcknowledgeEventType_ConditionSubClassName((int) 31950L),
  AuditConditionConfirmEventType_ConditionClassId((int) 31951L),
  AuditConditionConfirmEventType_ConditionClassName((int) 31952L),
  AuditConditionConfirmEventType_ConditionSubClassId((int) 31953L),
  AuditConditionConfirmEventType_ConditionSubClassName((int) 31954L),
  AuditConditionShelvingEventType_ConditionClassId((int) 31955L),
  AuditConditionShelvingEventType_ConditionClassName((int) 31956L),
  AuditConditionShelvingEventType_ConditionSubClassId((int) 31957L),
  AuditConditionShelvingEventType_ConditionSubClassName((int) 31958L),
  AuditConditionSuppressionEventType_ConditionClassId((int) 31959L),
  AuditConditionSuppressionEventType_ConditionClassName((int) 31960L),
  AuditConditionSuppressionEventType_ConditionSubClassId((int) 31961L),
  AuditConditionSuppressionEventType_ConditionSubClassName((int) 31962L),
  AuditConditionSilenceEventType_ConditionClassId((int) 31963L),
  AuditConditionSilenceEventType_ConditionClassName((int) 31964L),
  AuditConditionSilenceEventType_ConditionSubClassId((int) 31965L),
  AuditConditionSilenceEventType_ConditionSubClassName((int) 31966L),
  AuditConditionResetEventType_ConditionClassId((int) 31967L),
  AuditConditionResetEventType_ConditionClassName((int) 31968L),
  AuditConditionResetEventType_ConditionSubClassId((int) 31969L),
  AuditConditionResetEventType_ConditionSubClassName((int) 31970L),
  AuditConditionOutOfServiceEventType_ConditionClassId((int) 31971L),
  AuditConditionOutOfServiceEventType_ConditionClassName((int) 31972L),
  AuditConditionOutOfServiceEventType_ConditionSubClassId((int) 31973L),
  AuditConditionOutOfServiceEventType_ConditionSubClassName((int) 31974L),
  AuditProgramTransitionEventType_ConditionClassId((int) 31991L),
  AuditProgramTransitionEventType_ConditionClassName((int) 31992L),
  AuditProgramTransitionEventType_ConditionSubClassId((int) 31993L),
  AuditProgramTransitionEventType_ConditionSubClassName((int) 31994L),
  AuditHistoryEventUpdateEventType_ConditionClassId((int) 31999L),
  AuditHistoryEventUpdateEventType_ConditionClassName((int) 32000L),
  AuditHistoryEventUpdateEventType_ConditionSubClassId((int) 32001L),
  AuditHistoryEventUpdateEventType_ConditionSubClassName((int) 32002L),
  AuditHistoryValueUpdateEventType_ConditionClassId((int) 32003L),
  AuditHistoryValueUpdateEventType_ConditionClassName((int) 32004L),
  AuditHistoryValueUpdateEventType_ConditionSubClassId((int) 32005L),
  AuditHistoryValueUpdateEventType_ConditionSubClassName((int) 32006L),
  AuditHistoryAnnotationUpdateEventType_ConditionClassId((int) 32007L),
  AuditHistoryAnnotationUpdateEventType_ConditionClassName((int) 32008L),
  AuditHistoryAnnotationUpdateEventType_ConditionSubClassId((int) 32009L),
  AuditHistoryAnnotationUpdateEventType_ConditionSubClassName((int) 32010L),
  AuditHistoryDeleteEventType_ConditionClassId((int) 32011L),
  AuditHistoryDeleteEventType_ConditionClassName((int) 32012L),
  AuditHistoryDeleteEventType_ConditionSubClassId((int) 32013L),
  AuditHistoryDeleteEventType_ConditionSubClassName((int) 32014L),
  AuditHistoryRawModifyDeleteEventType_ConditionClassId((int) 32015L),
  AuditHistoryRawModifyDeleteEventType_ConditionClassName((int) 32016L),
  AuditHistoryRawModifyDeleteEventType_ConditionSubClassId((int) 32017L),
  AuditHistoryRawModifyDeleteEventType_ConditionSubClassName((int) 32018L),
  AuditHistoryAtTimeDeleteEventType_ConditionClassId((int) 32019L),
  AuditHistoryAtTimeDeleteEventType_ConditionClassName((int) 32020L),
  AuditHistoryAtTimeDeleteEventType_ConditionSubClassId((int) 32021L),
  AuditHistoryAtTimeDeleteEventType_ConditionSubClassName((int) 32022L),
  AuditHistoryEventDeleteEventType_ConditionClassId((int) 32023L),
  AuditHistoryEventDeleteEventType_ConditionClassName((int) 32024L),
  AuditHistoryEventDeleteEventType_ConditionSubClassId((int) 32025L),
  AuditHistoryEventDeleteEventType_ConditionSubClassName((int) 32026L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableAudit> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableAudit value : OpcuaNodeIdServicesVariableAudit.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableAudit(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableAudit enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
