/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableDiscrete {
  DiscreteItemType_Definition((int) 3776L),
  DiscreteItemType_ValuePrecision((int) 3777L),
  DiscreteAlarmType_EventId((int) 10524L),
  DiscreteAlarmType_EventType((int) 10525L),
  DiscreteAlarmType_SourceNode((int) 10526L),
  DiscreteAlarmType_SourceName((int) 10527L),
  DiscreteAlarmType_Time((int) 10528L),
  DiscreteAlarmType_ReceiveTime((int) 10529L),
  DiscreteAlarmType_LocalTime((int) 10530L),
  DiscreteAlarmType_Message((int) 10531L),
  DiscreteAlarmType_Severity((int) 10532L),
  DiscreteAlarmType_ConditionName((int) 10533L),
  DiscreteAlarmType_BranchId((int) 10534L),
  DiscreteAlarmType_Retain((int) 10535L),
  DiscreteAlarmType_EnabledState((int) 10536L),
  DiscreteAlarmType_EnabledState_Id((int) 10537L),
  DiscreteAlarmType_EnabledState_Name((int) 10538L),
  DiscreteAlarmType_EnabledState_Number((int) 10539L),
  DiscreteAlarmType_EnabledState_EffectiveDisplayName((int) 10540L),
  DiscreteAlarmType_EnabledState_TransitionTime((int) 10541L),
  DiscreteAlarmType_EnabledState_EffectiveTransitionTime((int) 10542L),
  DiscreteAlarmType_EnabledState_TrueState((int) 10543L),
  DiscreteAlarmType_EnabledState_FalseState((int) 10544L),
  DiscreteAlarmType_Quality((int) 10545L),
  DiscreteAlarmType_Quality_SourceTimestamp((int) 10546L),
  DiscreteAlarmType_LastSeverity((int) 10547L),
  DiscreteAlarmType_LastSeverity_SourceTimestamp((int) 10548L),
  DiscreteAlarmType_Comment((int) 10549L),
  DiscreteAlarmType_Comment_SourceTimestamp((int) 10550L),
  DiscreteAlarmType_ClientUserId((int) 10551L),
  DiscreteAlarmType_AddComment_InputArguments((int) 10555L),
  DiscreteAlarmType_ConditionRefresh_InputArguments((int) 10557L),
  DiscreteAlarmType_AckedState((int) 10558L),
  DiscreteAlarmType_AckedState_Id((int) 10559L),
  DiscreteAlarmType_AckedState_Name((int) 10560L),
  DiscreteAlarmType_AckedState_Number((int) 10561L),
  DiscreteAlarmType_AckedState_EffectiveDisplayName((int) 10562L),
  DiscreteAlarmType_AckedState_TransitionTime((int) 10563L),
  DiscreteAlarmType_AckedState_EffectiveTransitionTime((int) 10564L),
  DiscreteAlarmType_AckedState_TrueState((int) 10565L),
  DiscreteAlarmType_AckedState_FalseState((int) 10566L),
  DiscreteAlarmType_ConfirmedState((int) 10567L),
  DiscreteAlarmType_ConfirmedState_Id((int) 10568L),
  DiscreteAlarmType_ConfirmedState_Name((int) 10569L),
  DiscreteAlarmType_ConfirmedState_Number((int) 10570L),
  DiscreteAlarmType_ConfirmedState_EffectiveDisplayName((int) 10571L),
  DiscreteAlarmType_ConfirmedState_TransitionTime((int) 10572L),
  DiscreteAlarmType_ConfirmedState_EffectiveTransitionTime((int) 10573L),
  DiscreteAlarmType_ConfirmedState_TrueState((int) 10574L),
  DiscreteAlarmType_ConfirmedState_FalseState((int) 10575L),
  DiscreteAlarmType_Acknowledge_InputArguments((int) 10577L),
  DiscreteAlarmType_Confirm_InputArguments((int) 10579L),
  DiscreteAlarmType_ActiveState((int) 10580L),
  DiscreteAlarmType_ActiveState_Id((int) 10581L),
  DiscreteAlarmType_ActiveState_Name((int) 10582L),
  DiscreteAlarmType_ActiveState_Number((int) 10583L),
  DiscreteAlarmType_ActiveState_EffectiveDisplayName((int) 10584L),
  DiscreteAlarmType_ActiveState_TransitionTime((int) 10585L),
  DiscreteAlarmType_ActiveState_EffectiveTransitionTime((int) 10586L),
  DiscreteAlarmType_ActiveState_TrueState((int) 10587L),
  DiscreteAlarmType_ActiveState_FalseState((int) 10588L),
  DiscreteAlarmType_SuppressedState((int) 10589L),
  DiscreteAlarmType_SuppressedState_Id((int) 10590L),
  DiscreteAlarmType_SuppressedState_Name((int) 10591L),
  DiscreteAlarmType_SuppressedState_Number((int) 10592L),
  DiscreteAlarmType_SuppressedState_EffectiveDisplayName((int) 10593L),
  DiscreteAlarmType_SuppressedState_TransitionTime((int) 10594L),
  DiscreteAlarmType_SuppressedState_EffectiveTransitionTime((int) 10595L),
  DiscreteAlarmType_SuppressedState_TrueState((int) 10596L),
  DiscreteAlarmType_SuppressedState_FalseState((int) 10597L),
  DiscreteAlarmType_ShelvingState_CurrentState((int) 10599L),
  DiscreteAlarmType_ShelvingState_CurrentState_Id((int) 10600L),
  DiscreteAlarmType_ShelvingState_CurrentState_Name((int) 10601L),
  DiscreteAlarmType_ShelvingState_CurrentState_Number((int) 10602L),
  DiscreteAlarmType_ShelvingState_CurrentState_EffectiveDisplayName((int) 10603L),
  DiscreteAlarmType_ShelvingState_LastTransition((int) 10604L),
  DiscreteAlarmType_ShelvingState_LastTransition_Id((int) 10605L),
  DiscreteAlarmType_ShelvingState_LastTransition_Name((int) 10606L),
  DiscreteAlarmType_ShelvingState_LastTransition_Number((int) 10607L),
  DiscreteAlarmType_ShelvingState_LastTransition_TransitionTime((int) 10608L),
  DiscreteAlarmType_ShelvingState_UnshelveTime((int) 10609L),
  DiscreteAlarmType_ShelvingState_TimedShelve_InputArguments((int) 10634L),
  DiscreteAlarmType_SuppressedOrShelved((int) 10635L),
  DiscreteAlarmType_MaxTimeShelved((int) 10636L),
  DiscreteAlarmType_ConditionClassId((int) 11152L),
  DiscreteAlarmType_ConditionClassName((int) 11153L),
  DiscreteAlarmType_InputNode((int) 11154L),
  DiscreteAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime((int) 11481L),
  DiscreteAlarmType_ConditionRefresh2_InputArguments((int) 13005L),
  DiscreteAlarmType_ConditionSubClassId((int) 16900L),
  DiscreteAlarmType_ConditionSubClassName((int) 16901L),
  DiscreteAlarmType_OutOfServiceState((int) 16902L),
  DiscreteAlarmType_OutOfServiceState_Id((int) 16903L),
  DiscreteAlarmType_OutOfServiceState_Name((int) 16904L),
  DiscreteAlarmType_OutOfServiceState_Number((int) 16905L),
  DiscreteAlarmType_OutOfServiceState_EffectiveDisplayName((int) 16906L),
  DiscreteAlarmType_OutOfServiceState_TransitionTime((int) 16907L),
  DiscreteAlarmType_OutOfServiceState_EffectiveTransitionTime((int) 16908L),
  DiscreteAlarmType_OutOfServiceState_TrueState((int) 16909L),
  DiscreteAlarmType_OutOfServiceState_FalseState((int) 16910L),
  DiscreteAlarmType_SilenceState((int) 16911L),
  DiscreteAlarmType_SilenceState_Id((int) 16912L),
  DiscreteAlarmType_SilenceState_Name((int) 16913L),
  DiscreteAlarmType_SilenceState_Number((int) 16914L),
  DiscreteAlarmType_SilenceState_EffectiveDisplayName((int) 16915L),
  DiscreteAlarmType_SilenceState_TransitionTime((int) 16916L),
  DiscreteAlarmType_SilenceState_EffectiveTransitionTime((int) 16917L),
  DiscreteAlarmType_SilenceState_TrueState((int) 16918L),
  DiscreteAlarmType_SilenceState_FalseState((int) 16919L),
  DiscreteAlarmType_AudibleEnabled((int) 16920L),
  DiscreteAlarmType_AudibleSound((int) 16921L),
  DiscreteAlarmType_OnDelay((int) 16926L),
  DiscreteAlarmType_OffDelay((int) 16927L),
  DiscreteAlarmType_FirstInGroupFlag((int) 16928L),
  DiscreteAlarmType_ReAlarmTime((int) 16931L),
  DiscreteAlarmType_ReAlarmRepeatCount((int) 16932L),
  DiscreteAlarmType_ShelvingState_AvailableStates((int) 17692L),
  DiscreteAlarmType_ShelvingState_AvailableTransitions((int) 17693L),
  DiscreteAlarmType_AudibleSound_ListId((int) 17942L),
  DiscreteAlarmType_AudibleSound_AgencyId((int) 17943L),
  DiscreteAlarmType_AudibleSound_VersionId((int) 17944L),
  DiscreteAlarmType_LatchedState((int) 18307L),
  DiscreteAlarmType_LatchedState_Id((int) 18308L),
  DiscreteAlarmType_LatchedState_Name((int) 18309L),
  DiscreteAlarmType_LatchedState_Number((int) 18310L),
  DiscreteAlarmType_LatchedState_EffectiveDisplayName((int) 18311L),
  DiscreteAlarmType_LatchedState_TransitionTime((int) 18312L),
  DiscreteAlarmType_LatchedState_EffectiveTransitionTime((int) 18313L),
  DiscreteAlarmType_LatchedState_TrueState((int) 18314L),
  DiscreteAlarmType_LatchedState_FalseState((int) 18315L),
  DiscreteAlarmType_Suppress2_InputArguments((int) 24429L),
  DiscreteAlarmType_Unsuppress2_InputArguments((int) 24431L),
  DiscreteAlarmType_RemoveFromService2_InputArguments((int) 24433L),
  DiscreteAlarmType_PlaceInService2_InputArguments((int) 24435L),
  DiscreteAlarmType_Reset2_InputArguments((int) 24437L),
  DiscreteAlarmType_ShelvingState_TimedShelve2_InputArguments((int) 24907L),
  DiscreteAlarmType_ShelvingState_Unshelve2_InputArguments((int) 24909L),
  DiscreteAlarmType_ShelvingState_OneShotShelve2_InputArguments((int) 24911L),
  DiscreteAlarmType_GetGroupMemberships_OutputArguments((int) 25168L),
  DiscreteAlarmType_SupportsFilteredRetain((int) 32236L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableDiscrete> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableDiscrete value : OpcuaNodeIdServicesVariableDiscrete.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableDiscrete(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableDiscrete enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
